package com.netiq.nam.oauth.helpers;

import javax.ws.rs.core.SecurityContext;
import java.security.Principal;

/**
 * Created by tsureshkumar on 12/7/14.
 */

public class OAuth2SecurityContext implements SecurityContext {
    private Token token;
    private boolean isSecure;
    private OAuth2Principal oAuth2Principal;

    public OAuth2SecurityContext(Token token, boolean isSecure) {
        this.token = token;
        this.isSecure = isSecure;
        oAuth2Principal = new OAuth2Principal(token);
    }

    @Override
    public Principal getUserPrincipal() {
        return oAuth2Principal;
    }

    @Override
    public boolean isUserInRole(String role) {
        return false;
    }

    @Override
    public boolean isSecure() {
        return isSecure;
    }

    @Override
    public String getAuthenticationScheme() {
        return null;
    }
}
