package com.netiq.nam.oauth.helpers;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.api.client.util.Key;

import java.util.List;

/**
* Created by tsureshkumar on 12/7/14.
*/
public class Token {

    @JsonProperty(value = "expires_in")
    public long getExpiresIn() {
        return expires_in;
    }

    @JsonProperty(value = "scope")
    public List<String> getScope() {
        return scope;
    }

    @JsonProperty(value = "user")
    public String getUser() {
        return user_id;
    }

    @Key
    private long expires_in;
    @Key
    private List<String> scope;
    @Key
    private String user_id;

    private long receivedTime = 0;

    public boolean isExpired() {
        boolean result = expires_in <= 0;
        if(!result) {
            result = (receivedTime + expires_in) < System.currentTimeMillis();
        }
        return result;
    }

    public void setReceivedTime(long receivedTime) {
        this.receivedTime = receivedTime;
    }

    public long getReceivedTime() {
        return receivedTime;
    }

    public void setExpiresIn(long expires_in) {
        this.expires_in = expires_in;
    }

    public void setScope(List<String> scope) {
        this.scope = scope;
    }

    public void setUser(String user) {
        this.user_id = user;
    }
}
