package com.netiq.nam.oauth.servlets;

import com.google.api.client.auth.oauth2.AuthorizationCodeFlow;
import com.google.api.client.extensions.servlet.auth.oauth2.AbstractAuthorizationCodeServlet;
import com.google.api.client.http.GenericUrl;
import com.netiq.nam.oauth.helpers.OAuth2Helper;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.logging.Logger;

/**
 * Created by tsureshkumar on 12/7/14.
 */
/*
* based on https://code.google.com/p/google-oauth-java-client/wiki/OAuth2#Servlet_authorization_code_flow
* This servlet make sure that derived debug from this, are protected by OAuth2 based authentication
 */
public class OAuth2ProtectedServlet extends AbstractAuthorizationCodeServlet {
    static Logger logger = Logger.getLogger(AbstractAuthorizationCodeServlet.class.getName());

    @Override
    protected AuthorizationCodeFlow initializeFlow() throws ServletException, IOException {
        return OAuth2Helper.getInstance().getFlow();
    }

    @Override
    protected String getRedirectUri(HttpServletRequest req) throws ServletException, IOException {
        GenericUrl url = new GenericUrl(req.getRequestURL().toString());
        url.setRawPath("/oauth2callback");
        return url.build();
    }

    @Override
    protected String getUserId(HttpServletRequest req) throws ServletException, IOException {
        return (String) req.getSession(true).getId();
    }
}
