package com.netiq.nam.oauth.authz_sample.app.debug;

import com.netiq.nam.oauth.helpers.OAuth2Helper;
import com.netiq.nam.oauth.servlets.OAuth2ProtectedServlet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;

/**
 * Created by tsureshkumar on 12/7/14.
 */
public class UserInfoServlet extends OAuth2ProtectedServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        Map<String,Object> userinfo = OAuth2Helper.getInstance().getUserInfo(req.getSession().getId());
        if (userinfo != null) {
            req.setAttribute("userinfo", userinfo);

            PrintWriter writer = resp.getWriter();
            writer.write("<html><head>\n" +
                    "        <link rel=\"stylesheet\" type=\"text/css\" href=\"css/main.css\"/>\n" +
                    "    </head><body>");
            req.getRequestDispatcher("/menu.jsp").include(req, resp);
            writer.write("<table>");
            userinfo.keySet().stream().forEach(k -> {
                writer.write("<tr><td>"+k+"</td>");
                writer.write("<td>" + userinfo.get(k).toString()+"</td>");
                writer.write("</tr>");
            });
            writer.write("</table>");
            writer.write("</body></html>");
        } else {
            resp.sendError(500);
            resp.getWriter().write("error getting user info");
            return;
        }

    }
}
